--Contra NES Collision Box Viewer
--For FCEUX 2.2.X
--Author Pasky
 
local function draw_axis(x,y)
    gui.line(x,y-4,x,y+4)
    gui.line(x-4,y,x+4,y)
end
 
local function player()
    local x = memory.readbyte(0x334)
    local y = memory.readbyte(0x31A)
    --print(string.format("Player X: %s Player Y: %s", x, y))
    draw_axis(x,y)
end
 
 local function health()
 	local healthOne = memory.readbyte(0x583)
 	local healthTwo = memory.readbyte(0x584)
 	local healthThree = memory.readbyte(0x585)
 	local healthFour = memory.readbyte(0x586)
 	local healthFive = memory.readbyte(0x587)
 	gui.text(215, 180, string.format("HP: %s", healthOne, "white"))
 	gui.text(215, 190, string.format("HP: %s", healthTwo, "white"))
 	gui.text(215, 200, string.format("HP: %s", healthThree, "white"))
 	gui.text(215, 210, string.format("HP: %s", healthFour, "white"))
 	gui.text(215, 220, string.format("HP: %s", healthFive, "white"))
 end

local function enemies()
    local x
    local y
    local xrad
    local xoff
    local yoff
    local yrad
    memory.registerexec(0xE42E,function()
            x = memory.readbyte(0x33E + memory.getregister("X"))
            y = memory.readbyte(0x324 + memory.getregister("X"))
            xoff = memory.readbytesigned(memory.readword(0x0E) + memory.getregister("Y") + 1)
            yoff = memory.readbytesigned(memory.readword(0x0E) + memory.getregister("Y"))
            xrad = memory.readbyte(memory.readword(0x0E) + (memory.getregister("Y") +3))
            yrad = memory.readbyte(memory.readword(0x0E) + (memory.getregister("Y") +2))
            gui.box(x + xoff + xrad, y + yoff + yrad, x + xoff , y + yoff)
    end)
end
 
while true do
    player()
    enemies()
    health()
    emu.frameadvance()
end
